<?xml version="1.0"?>
<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.3//EN"
   "http://www.oasis-open.org/docbook/xml/4.3/docbookx.dtd"
[
 <!ENTITY % local.common.attrib "xmlns:xi CDATA #FIXED 'http://www.w3.org/2003/XInclude'">
 <!ENTITY % gtkdocentities SYSTEM "xml/gtkdocentities.ent">
 %gtkdocentities;
]>

<part id="api-breaks">
  <title>API Breaks</title>

  <chapter id="api-breaks-1-to-2">
    <title>Gtef 1 -> Gtef 2</title>

    <itemizedlist>
      <listitem>
        <para>
          The <code>GtefBuffer::cursor-moved</code> signal has been renamed to
          <code>GtefBuffer::gtef-cursor-moved</code>.
        </para>
      </listitem>
      <listitem>
        <para>
          The <code>GtefBuffer:title</code> property has been renamed to
          <code>GtefBuffer:gtef-title</code>.
        </para>
      </listitem>
    </itemizedlist>
  </chapter>

  <chapter id="api-breaks-2-to-3-tepl">
    <title>Gtef 2 -> Tepl 3</title>

    <itemizedlist>
      <listitem>
        <para>
          The library has been renamed to Tepl (Text editor product line). So
          the namespace of the code has changed.
        </para>
        <para>
          The new version is Tepl&nbsp;3 and not Tepl&nbsp;1, to avoid confusion
          with the git tags (the git repository is still the same), since the
          repository already contains tags for versions 1 and 2.
        </para>
      </listitem>
      <listitem>
        <para>
          The <link linkend="TeplTab">TeplTab</link> class has been revamped.
          The <link linkend="tepl-tab-new">tepl_tab_new()</link> function
          doesn't take a <link linkend="GtkWidget">GtkWidget</link> parameter
          anymore, a <link linkend="TeplView">TeplView</link> is created
          instead.
        </para>
      </listitem>
      <listitem>
        <para>
          The <code>TeplBuffer:tepl-title</code> property has been renamed to
          <link linkend="TeplBuffer--tepl-full-title">TeplBuffer:tepl-full-title</link>,
          and <code>tepl_buffer_get_title()</code> has been renamed to
          <link linkend="tepl-buffer-get-full-title">tepl_buffer_get_full_title()</link>.
        </para>
      </listitem>
    </itemizedlist>
  </chapter>

  <chapter id="api-breaks-2-to-3-amtk">
    <title>Gtef 2 -> Amtk 3</title>

    <itemizedlist>
      <listitem>
        <para>
          The classes and functions related to actions and menus have been moved
          to a new shared library called Amtk (Actions, Menus and Toolbars Kit),
          since it was not really related to text editors, it is more general.
          But Amtk is still developed inside the Tepl repository.
        </para>
      </listitem>
      <listitem>
        <para>
          The <link linkend="AmtkFactory">AmtkFactory</link> class has been
          added, which replace <code>gtef_action_info_store_create_menu_item()</code>
          and removes the <code>GtefActionInfoStore:application</code> property.
        </para>
      </listitem>
      <listitem>
        <para>
          <code>gtef_action_info_central_store_get_instance()</code> has been
          renamed to
          <link linkend="amtk-action-info-central-store-get-singleton">amtk_action_info_central_store_get_singleton()</link>.
        </para>
      </listitem>
      <listitem>
        <para>
          <link linkend="amtk-application-window-connect-menu-to-statusbar">amtk_application_window_connect_menu_to_statusbar()</link>
          now takes a <link linkend="GtkMenuShell">GtkMenuShell</link> parameter
          instead of <link linkend="AmtkMenuShell">AmtkMenuShell</link>.
        </para>
      </listitem>
    </itemizedlist>
  </chapter>

  <chapter id="api-breaks-3-to-4-tepl">
    <title>Tepl 3 -> Tepl 4</title>

    <itemizedlist>
      <listitem>
        <para>
          Tepl&nbsp;3 depended on GtkSourceView&nbsp;3, Tepl&nbsp;4 depends on
          GtkSourceView&nbsp;4. So to be able to use Tepl&nbsp;4, you need to
          port your code to GtkSourceView&nbsp;4. Note that the GTK dependency
          is still GTK&nbsp;3.
        </para>
      </listitem>
      <listitem>
        <para>
          The <link linkend="TeplTab-close-request">TeplTab::close-request</link>
          signal has now a default object method handler.
        </para>
      </listitem>
    </itemizedlist>
  </chapter>

  <chapter id="api-breaks-4-to-5-tepl">
    <title>Tepl 4 -> Tepl 5</title>

    <itemizedlist>
      <listitem>
        <para>
          The <code>TeplEncoding</code> class has been removed, as part of the
          beginning of a complete overhaul of the file loading and saving
          functionality.
        </para>
      </listitem>
      <listitem>
        <para>
          Start to rework the <link linkend="TeplFile">TeplFile</link>,
          <link linkend="TeplFileLoader">TeplFileLoader</link> and
          <link linkend="TeplFileSaver">TeplFileSaver</link> classes. As such,
          there are some API breaks in those classes. And as a result, they
          currently contain less features as before, unfortunately.
        </para>
      </listitem>
      <listitem>
        <para>
          The <link linkend="TeplMetadataManager">TeplMetadataManager</link> API
          has been re-worked.
        </para>
      </listitem>
      <listitem>
        <para>
          The <code>TeplFileMetadata</code> class has been replaced by
          <link linkend="TeplMetadata">TeplMetadata</link>, the latter no longer
          depends on <link linkend="TeplFile">TeplFile</link>.
        </para>
      </listitem>
      <listitem>
        <para>
          The <code>tepl_file_get_file_metadata()</code> function has been
          removed.
        </para>
      </listitem>
      <listitem>
        <para>
          The <link linkend="tepl-tab-load-file">tepl_tab_load_file()</link>
          function no longer loads the file metadata (but it was anyway an
          implementation detail).
        </para>
      </listitem>
      <listitem>
        <para>
          The <code>TeplAbstractFactoryVala</code> class has been removed,
          because it's possible to manually manage GObject references in Vala.
        </para>
      </listitem>
    </itemizedlist>
  </chapter>

  <chapter id="api-breaks-5-to-6-tepl">
    <title>Tepl 5 -> Tepl 6</title>

    <itemizedlist>
      <listitem>
        <para>
          The <link linkend="tepl-info-bar-set-buttons-orientation">tepl_info_bar_set_buttons_orientation()</link>
          now takes a <link linkend="GtkInfoBar">GtkInfoBar</link> parameter,
          not a <link linkend="TeplInfoBar">TeplInfoBar</link>.
        </para>
      </listitem>
      <listitem>
        <para>
          The <code>tepl_info_bar_add_close_button()</code> function has been
          renamed to
          <link linkend="tepl-info-bar-setup-close-button">tepl_info_bar_setup_close_button()</link>.
        </para>
      </listitem>
      <listitem>
        <para>
          The <code>tepl_info_bar_add_icon()</code> function has been replaced by
          <link linkend="tepl-info-bar-set-icon-from-message-type">tepl_info_bar_set_icon_from_message_type()</link>.
        </para>
      </listitem>
      <listitem>
        <para>
          A <code>location</code> parameter has been added to the
          <link linkend="tepl-info-bar-add-content-widget">tepl_info_bar_add_content_widget()</link>
          function.
        </para>
      </listitem>
    </itemizedlist>
  </chapter>

  <chapter id="api-breaks-during-tepl-6">
    <title>API breaks during Tepl 6</title>

    <para>
      There are also ABI breaks not affecting the API, so just re-compiling the
      program is sufficient in that case.
    </para>

    <para>
      Tepl 6.0 to Tepl 6.2:
    </para>
    <itemizedlist>
      <listitem>
        <para>
          The <code>tepl_utils_override_font()</code> function has been renamed
          to <link linkend="tepl-utils-override-font-string">tepl_utils_override_font_string()</link>.
        </para>
      </listitem>
    </itemizedlist>

    <para>
      Tepl 6.2 to Tepl 6.4:
    </para>
    <itemizedlist>
      <listitem>
        <para>
          The <code>tepl_statusbar_*()</code> functions have been removed, you
          can use
          <link linkend="TeplLineColumnIndicator">TeplLineColumnIndicator</link>
          instead.
        </para>
      </listitem>
    </itemizedlist>

    <para>
      Tepl 6.4 to Tepl 6.6:
    </para>
    <itemizedlist>
      <listitem>
        <para>
          Tepl now depends on libgedit-gtksourceview instead of GtkSourceView.
        </para>
      </listitem>
      <listitem>
        <para>
          The <code>TeplWidgetListItem</code> and
          <code>TeplWidgetListCategory</code> classes have been removed.
        </para>
      </listitem>
    </itemizedlist>

    <para>
      Tepl 6.6 to Tepl 6.8:
    </para>
    <itemizedlist>
      <listitem>
        <para>
          The <code>TeplPanel</code> class has been renamed to
          <link linkend="TeplPanel1">TeplPanel1</link>.
        </para>
      </listitem>
      <listitem>
        <para>
          The <code>TeplStack</code>, <code>TeplStackItem</code> and
          <code>TeplStackSwitcherMenu</code> classes have been removed. They are
          superseded by <link linkend="TeplPanel">TeplPanel</link> (and related
          classes and interfaces).
        </para>
      </listitem>
      <listitem>
        <para>
          The <code>TeplStatusbar</code> class has been removed, and is replaced
          by <link linkend="tepl-utils-setup-statusbar">tepl_utils_setup_statusbar()</link>.
        </para>
      </listitem>
    </itemizedlist>

    <para>
      Tepl 6.8 to libgedit-tepl 6.10:
    </para>
    <itemizedlist>
      <listitem>
        <para>
          Tepl has been renamed to libgedit-tepl. The new pkg-config name is:
          <code>libgedit-tepl-6</code>
        </para>
      </listitem>
      <listitem>
        <para>
          <link linkend="TeplFile">TeplFile</link> now uses
          <link linkend="GflsUnsavedDocumentTitles">GflsUnsavedDocumentTitles</link>.
          This affects the
          <link linkend="TeplFile--short-name">TeplFile:short-name</link>
          property. Also, <code>tepl_file_set_untitled_file_callback()</code>
          and <code>TeplUntitledFileCallback</code> have been removed.
        </para>
      </listitem>
    </itemizedlist>

    <para>
      libgedit-tepl 6.10 to 6.11:
    </para>
    <itemizedlist>
      <listitem>
        <para>
          The <code>TeplSettingsSimpleThemeVariant</code> enum,
          <code>tepl_settings_handle_simple_theme_variant()</code> and
          <code>tepl_prefs_create_simple_theme_variant_combo_box()</code> have
          been removed. You can use instead the more complete
          <link linkend="TeplSettingsThemeVariant">TeplSettingsThemeVariant</link>
          enum and the functions that use it.
        </para>
      </listitem>
      <listitem>
        <para>
          <code>tepl_buffer_provide_style_scheme_id_gsetting()</code> has been
          removed. Use <link linkend="TeplSettings">TeplSettings</link> instead
          to provide two GSettings keys instead of one.
        </para>
        <para>
          The <code>TeplBuffer:tepl-style-scheme-id</code> property,
          <code>tepl_buffer_get_style_scheme_id()</code> and
          <code>tepl_buffer_set_style_scheme_id()</code> have been removed.
          You can use
          <link linkend="tepl-buffer-connect-style-scheme-settings">tepl_buffer_connect_style_scheme_settings()</link>
          instead.
        </para>
      </listitem>
      <listitem>
        <para>
          <code>tepl_prefs_create_color_scheme_component()</code> and the
          <code>TeplStyleSchemeChooserWidget</code> class have been removed.
          They are replaced by
          <link linkend="TeplStyleSchemeChooserSimple">TeplStyleSchemeChooserSimple</link> and
          <link linkend="TeplStyleSchemeChooserFull">TeplStyleSchemeChooserFull</link>.
        </para>
      </listitem>
      <listitem>
        <para>
          <link linkend="TeplTabLabel">TeplTabLabel</link> now inherits from
          <code>GtkBox</code> instead of <code>GtkGrid</code>.
        </para>
      </listitem>
      <listitem>
        <para>
          <link linkend="TeplPanelItem">TeplPanelItem</link> is now a GObject
          class instead of an interface.
        </para>
      </listitem>
      <listitem>
        <para>
          The API of <link linkend="tepl-panel-add">tepl_panel_add()</link> and
          its vfunc have changed.
        </para>
      </listitem>
      <listitem>
        <para>
          The API of
          <link linkend="TeplPanelSwitcherMenu">TeplPanelSwitcherMenu</link>
          has changed.
        </para>
      </listitem>
      <listitem>
        <para>
          The <code>TeplPanelSwitcherNotebook</code> class has been removed, you
          can use <link linkend="TeplPanelNotebook">TeplPanelNotebook</link>
          instead.
        </para>
      </listitem>
      <listitem>
        <para>
          The <code>TeplPanelContainer</code> class has been removed, you can
          use <link linkend="TeplPanelSimple">TeplPanelSimple</link> instead.
        </para>
      </listitem>
    </itemizedlist>

    <para>
      libgedit-tepl 6.11 to 6.12:
    </para>
    <itemizedlist>
      <listitem>
        <para>
          The <code>tepl_prefs_create_display_grid_checkbutton()</code> function
          has been removed.
        </para>
      </listitem>
    </itemizedlist>

    <para>
      libgedit-tepl 6.12 to 6.13:
    </para>
    <itemizedlist>
      <listitem>
        <para>
          The <code>tepl_abstract_factory_fill_prefs_dialog()</code> function
          and its vfunc have been replaced by
          <link linkend="tepl-abstract-factory-create-prefs-dialog">tepl_abstract_factory_create_prefs_dialog()</link>.
        </para>
      </listitem>
      <listitem>
        <para>
          The <code>TeplEncoding</code> interface and the
          <code>TeplEncodingIconv</code> class have been removed.
        </para>
      </listitem>
    </itemizedlist>
  </chapter>
</part>
